/*..............................rodssG.sas.....................*/
/* modification of pedigree and SNP file for ssGBLUP in blupf90*/
/*...............................................8.7.2014 VUZV */
filename rod  "c:\J\pp\GDny\skoleni\blupf90/ssgblu/rod";
filename rod2 "c:\J\pp\GDny\skoleni\blupf90/ssgblu/rod2";
filename genot "c:\J\pp\GDny\skoleni\blupf90/ssgblu/genot";
filename genot2 "c:\J\pp\GDny\skoleni\blupf90/ssgblu/genot2";
filename XrefID "c:\J\pp\GDny\skoleni\blupf90/ssgblu/genot2_XrefID";
filename Gstar "c:\J\pp\GDny\skoleni\blupf90/ssgblu/gemat";
filename Gnov "c:\J\pp\GDny\skoleni\blupf90/ssgblu/gemat2";
dm output 'clear';
dm log 'clear';
/*........................pedigree......................*/
data rod;									/* reading */
	infile rod ;
		input j o m ;
		ch = 0 ;
	file rod2;
		put j o m ch ch ch ch ch ch j ;
/*..........................SNP.........................*/
data genot ;
format sn1 - sn40 $1. ;
	array s sn1 - sn40 ;
infile genot ;
	input j sn1 - sn40;
proc sort ; by j ;
data a ;
	set genot ;
 		ch = " " ;			
	file genot2 ;
		put j 1-3 ch 1. (sn1 - sn40) (1.) ;
	file XrefID ;	/*.......... list of genot........*/
		put j j ;
	proc means ;
/*.............. sequence number of genot animals...........*/
data cisel ;
	set a ;
		cg = _n_ ;	
	keep j cg ;
	proc means ;
/*..................sequence number into matrix G ..........*/
data g ;
	Infile gstar ;
		input j j2 g ;
	proc sort ; by j ;
data b ;
	merge cisel g ; by j ;
		nj1 = cg ;
		j = j2 ;	
		keep nj1 j g ;
	proc sort ; by j ;
data c ;
	merge cisel b ; by j ;
	nj2 = cg ;
	file gnov ;
		put nj1 nj2 g ;
	proc means ;
run;/*.........................finish....................*/
